// puzzle game for window console
// gcc puzzle_console.c -o puzzle.exe
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

int g_row = 4;		// Ŀ
int g_line = 4;		// Ŀ
int g_puzzle[5*7];	// ƴͼ

// clear screen
// 
void Clrscr()
{
	HANDLE hConsole;
	COORD coordScreen = {0, 0};
	DWORD cCharsWritten; 
	DWORD dwConSize;
	CONSOLE_SCREEN_BUFFER_INFO csbi;

	hConsole=GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(hConsole, &csbi);
	dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

	FillConsoleOutputCharacter(hConsole, (TCHAR)' ',
		dwConSize, coordScreen, &cCharsWritten);
}

// 
void GotoXY(int x, int y)
{
	HANDLE hConsole;
	COORD pt;

	pt.X = x; pt.Y = y;
	hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleCursorPosition(hConsole, pt);
}

// ƴͼż
int CalcParity(int *puzzle, int size, int row)
{
	int ret = 0;
	int i, j;
	// еż
	for (i=0; i<size; i++)
	{
		for (j=i+1; j<size; j++)
		{
			if (puzzle[i] > puzzle[j])
				ret++;
		}
	}

	// 0Ԫλ
	for (i=0; i<size; i++)
	{
		if (puzzle[i] == 0)
			break;
	}
	ret += i%row + i/row;
	return ret;
}

// ƴͼǷԭ
int IsPuzzleFinished()
{
	int i;
	for (i=0; i<g_line*g_row-1; i++)
	{
		if (g_puzzle[i] != i+1)
			return 0;
	}
	return 1;
}

// ɢƴͼ
void RandomPuzzle()
{
	srand(GetTickCount());
	int size = g_line * g_row;
	int i = 0;
	while ( i<size )
	{
		g_puzzle[i] = rand() % size;
		int j;
		for (j=0; j<i; j++)
		{
			if (g_puzzle[i] == g_puzzle[j])
				goto USELESS;
		}
		i++;
USELESS:
		;
	}

	// жƴͼż
	if (CalcParity(g_puzzle, size, g_row)%2 != (size-1+g_line-1+g_row-1)%2)
	{
		// ȣǿԪء
		int t, t1, t2;
		if (g_puzzle[0] == 0)
		{
			t1 = 1; t2 = 2;
		}
		else if (g_puzzle[1] == 0)
		{
			t1 = 0; t2 = 2;
		}
		else 
		{
			t1 = 0; t2 = 1;
		}
		t = g_puzzle[t1];
		g_puzzle[t1] = g_puzzle[t2];
		g_puzzle[t2] = t;
	}
}

// ʾ˵
void PrintMainMenu()
{
	Clrscr();
	GotoXY(0, 0);
	printf("1.Begin game!\n");
	printf("2.Adjust line(%d) and row(%d)\n", g_line, g_row);
	printf("3.Quit\n");
}

// ʾƴͼ
void PrintPuzzle()
{
	HANDLE hConsole;
	COORD coordScreen = {0, 0};
	DWORD cCharsWritten; 
	DWORD dwConSize;
	CONSOLE_SCREEN_BUFFER_INFO csbi;

	hConsole=GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(hConsole, &csbi);
	dwConSize = csbi.dwSize.X * csbi.dwSize.Y;
	int i, j;
	for (i=0; i<=g_line; i++)
	{
		for (j=0; j<g_row; j++)
		{
			coordScreen.Y = i*2; 
			coordScreen.X = j*4 + 1;
			FillConsoleOutputCharacter(hConsole, '-',
				3, coordScreen, &cCharsWritten);
		}
	}

	for (i=0; i<g_line; i++)
	{
		for (j=0; j<=g_row; j++)
		{
			coordScreen.Y = i*2+1; 
			coordScreen.X = j*4 ;
			FillConsoleOutputCharacter(hConsole, '|',
				1, coordScreen, &cCharsWritten);
		}
	}
	char str[4];
	for (i=0; i<g_line*g_row; i++)
	{
		coordScreen.Y = i/g_row*2 + 1; 
		coordScreen.X = i%g_row*4 + 1;
		if (g_puzzle[i] == 0)
		{
			sprintf(str, "   ");
		}
		else
			sprintf(str, "%3d", g_puzzle[i]);
		WriteConsoleOutputCharacter(hConsole, str,
			3, coordScreen, &cCharsWritten);
	}

	GotoXY(0, g_line*2+2);
	printf("use %c, %c, %c, %c to move item\n", 0x18, 0x19, 0x1a, 0x1b);
	printf("'Q' back to menu\n");

}

// ƴͼС
void AdjustLineAndRow()
{
	int line, row;
	Clrscr();
	GotoXY(0, 0);
	printf("Please input line(2-5):");
	scanf("%d", &line);
	printf("Please input row(2-7):");
	scanf("%d", &row);
	if (line >=2 && line <=5)
		g_line = line;
	if (row >=2 && row <=7)
		g_row = row;

}

// ƶƴͼ
void MovePuzzle(int direct)
{
	int i=0; 
	for (; i<g_line*g_row; i++)
		if (g_puzzle[i] == 0)
			break;

	switch (direct)
	{
	case 75:	// left;
		if (i%g_row != g_row-1)
		{
			g_puzzle[i] = g_puzzle[i+1];
			g_puzzle[i+1] = 0;
		}
		break;
	case 77:	// right
		if (i%g_row != 0)
		{
			g_puzzle[i] = g_puzzle[i-1];
			g_puzzle[i-1] = 0;
		}
		break;
	case 72:	// up
		if (i < g_line*g_row-g_row)
		{
			g_puzzle[i] = g_puzzle[i+g_row];
			g_puzzle[i+g_row] = 0;
		}
		break;
	case 80:	// down
		if (i >= g_row)
		{
			g_puzzle[i] = g_puzzle[i-g_row];
			g_puzzle[i-g_row] = 0;
		}
		break;
	}
}

// ʼƴͼϷ
void BeginGame()
{
	Clrscr();
	RandomPuzzle();
	PrintPuzzle();
	while (1)
	{	
		int c = getch();
		switch (c)
		{
		case 'q':
		case 'Q':
			return;
		case 0xe0:
			MovePuzzle(getch());
			break;			
		}
		PrintPuzzle();

		if (IsPuzzleFinished())
		{
			printf("Congratulation,you pass the game!\nAny key back to menu");
			getch();
			return;
		}
	}
	
	
}

int main()
{
	char cInput;
	while (1)
	{
		PrintMainMenu();
		cInput = getch();
		switch (cInput)
		{
		case 'Q':
		case 'q':
		case '3':
			Clrscr();
			GotoXY(0,0);
			goto End;
		case 'B':
		case 'b':
		case '1':
			BeginGame();
			break;
		case 'A':
		case 'a':
		case '2':
			AdjustLineAndRow();
			break;
		}
	}
End:
	return 0;
}

